// AnlCsv.c : STARFAX CSV͏
//

#include	"stdafx.h"

#include	"AnlCsv.h"

extern "C" {

/////////////////////////////////////////////////////////////////////////////
// }N`

#define	CheckDBS(c) ((0x80<=((unsigned char)c)&&((unsigned char)c)<=0x9f)||(0xe0<=((unsigned char)c)&&((unsigned char)c)<=0xfe))

/////////////////////////////////////////////////////////////////////////////
// \̒`

#pragma pack( push, 4 )

// CSV͍ڏ
typedef	struct	_ANLCSV_ITEM {
	char	*pItem;			// ڐ擪ʒu
	int	iItem;				// ڃoCg
}	ANLCSV_ITEM;

#pragma pack( pop )

//**********************************************************************
// ֐        : ANLCSV_Init
// @\          : CSV͏ݒ
// Ăяo      : INT ANLCSV_Init( ANLCSV_INFO *pInfo )
//           : pInfo = CSV͏
// o          : Ԓl  0     -> I
//               :       0ȊO -> G[
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
int	ANLCSV_Init( ANLCSV_INFO *pInfo )
{
	int	iRet;

	ZeroMemory( (PVOID)pInfo, sizeof(ANLCSV_INFO) );

	pInfo->pRecArray = new CPtrArray;
	if( !pInfo->pRecArray  ) {
		iRet = ANLCSV_Err_Memory;
		goto	EXIT;
	}

	iRet = ANLCSV_Success;

EXIT:

	if( iRet != ANLCSV_Success ) {
		ANLCSV_End( pInfo );
	}

	return iRet;
}

//**********************************************************************
// ֐        : ANLCSV_End
// @\          : CSV͌n
// Ăяo      : VOID ANLCSV_End( ANLCSV_INFO *pInfo )
//           : pInfo  = CSV͏
// o          : Ȃ
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
void	ANLCSV_End( ANLCSV_INFO *pInfo )
{
	if( pInfo->pRecArray ) {

		ANLCSV_ITEM	*pRecInfo;
		int	i;

		for( i = 0 ; i < pInfo->pRecArray->GetSize() ; i++ ) {
			pRecInfo = (ANLCSV_ITEM *)pInfo->pRecArray->GetAt( i );
			delete pRecInfo;
		}
		pInfo->pRecArray->RemoveAll();
		delete pInfo->pRecArray;
		pInfo->pRecArray = (CPtrArray *)NULL;
	}
}

//**********************************************************************
// ֐        : ANLCSV_AnalysisRecord
// @\          : CSVt@C1R[h
// Ăяo      : int ANLCSV_AnalysisRecord( ANLCSV_INFO *pInfo, char *pBuf, int iLen )
//           : pInfo = CSV͏
//               : pBuf  = R[h|C^
//               : iLen  = R[hoCg
// o          : Ԓl  ڐ (0͖)
//               :       l -> G[
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
int	ANLCSV_AnalysisRecord( ANLCSV_INFO *pInfo, char *pBuf, int iLen )
{
	int	iRet = 0;

	ANLCSV_ITEM	NewRec;
	ANLCSV_ITEM	*pRec;
	int	iCurRec;
	int	i;

	char	*pChk = pBuf;
	char	*pBufEnd = pBuf + iLen;

	for( i = 0 ; i < pInfo->iAssignNum ; i++ ) {
		if( ( pRec =  (ANLCSV_ITEM *)pInfo->pRecArray->GetAt( i ) ) != (ANLCSV_ITEM *)NULL ) {
			pRec->pItem = NULL;
			pRec->iItem = 0;
		}

	}

	pInfo->iRecNum = 0;
	iCurRec = 0;

	for( ;; pChk++ ) {

		BOOL	bEnd = FALSE;
		char	cEnd = ' ';

		if( pChk >= pBufEnd || ( *pChk == 0x0d || *pChk == 0x0a || *pChk == 0x1a ) ) {
				// R[hI
			goto	EXIT;
		}

		if( *pChk == 0x20 || *pChk == 0x09 ) {
			continue;
		}
		if( *pChk == '\"' ) {
			cEnd = '\"';	// "t
			pChk++;
			if( pChk >= pBufEnd || ( *pChk == 0x0d || *pChk == 0x0a || *pChk == 0x1a ) ) {
					// R[hI
				goto	EXIT;
			}
		}

		if( iCurRec >= pInfo->iAssignNum ) {

			ANLCSV_ITEM	*pAdd;

			ZeroMemory( &NewRec, sizeof(NewRec) );

			pAdd = new ANLCSV_ITEM;
			if( !pAdd ) {
				iRet = ANLCSV_Err_Memory;
				goto	EXIT;
			}
			CopyMemory( pAdd, &NewRec, sizeof(ANLCSV_ITEM) );
			pInfo->pRecArray->Add( pAdd );

			pInfo->iAssignNum++;
		}

		if( ( pRec = (ANLCSV_ITEM *)pInfo->pRecArray->GetAt( iCurRec ) ) == (ANLCSV_ITEM *)NULL ) {
			iRet = ANLCSV_Err_Memory;
			goto	EXIT;
		}
		pInfo->iRecNum++;
		iRet++;

		pRec->pItem = pChk;

		for( ; pChk < pBufEnd ; pChk++ ) {
			if( pChk >= pBufEnd || ( *pChk == 0x0d || *pChk == 0x0a || *pChk == 0x1a ) ) {
					// R[hI
				goto	EXIT;
			}
			if( !bEnd && *pChk == cEnd ) {
				if( ( cEnd == '\"' ) && ( *( pChk + 1 ) == '\"' ) ) {
					pRec->iItem++;
					pChk++;
					if( pChk >= pBufEnd ) {
						goto	EXIT;
					}
					pRec->iItem++;
				}
				else {
					bEnd = TRUE;
				}
				continue;
			}
			else if( CheckDBS( *pChk ) ) {
				if( !bEnd ) {
					pRec->iItem++;
				}
				pChk++;
				if( pChk >= pBufEnd ) {
					goto	EXIT;
				}
				if( !bEnd ) {
					pRec->iItem++;
				}
				continue;
			}
			if( *pChk == ',' ) {
				if( cEnd == ' ' ) {
					break;
				}
				else {
					if( bEnd ) {
						break;
					}
				}
			}
			if( !bEnd ) {
				pRec->iItem++;
			}
		}
		if( !pRec->iItem ) {
			pRec->pItem = (char *)NULL;
		}
		iCurRec++;
	}

EXIT:

	return iRet;
}

//**********************************************************************
// ֐        : ANLCSV_GetItemPointer
// @\          : ڃ|C^擾
// Ăяo      : INT ANLCSV_GetItemPointer( ANLCSV_INFO *pInfo, INT iItem, char **ppItem, char *piLen )
//           : pInfo   = CSV͏
//               : iItem   = ڈʒu
//               : ppItem  = ڃ|C^
//               : piLen   = oCg
// o          : Ԓl  0     -> I
//               :       0ȊO -> G[
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
int	ANLCSV_GetItemPointer( ANLCSV_INFO *pInfo, int iItem, char **ppItem, int *piLen )
{
	int	iRet = ANLCSV_Err_BadPara;

	ANLCSV_ITEM	*pRec;

	if( pInfo->pRecArray != (CPtrArray *)NULL ) {
		if( iItem < pInfo->iRecNum ) {
			if( ( pRec = (ANLCSV_ITEM *)pInfo->pRecArray->GetAt( iItem ) ) != (ANLCSV_ITEM *)NULL ) {
				iRet = ANLCSV_Success;
				*ppItem = pRec->pItem;
				*piLen = pRec->iItem;
			}
		}
	}

	return iRet;
}

}
